.TH SQUASHTYPES 1 "Jan 23 1996" "Stanford University" "SUIF Compiler"
.SH NAME
squashtypes \- collapse heirarchies of group types
.SH SYNOPSIS
.B squashtypes
.I infile
.I outfile
{
.I infile
.I outfile
} *
.SH DESCRIPTION
The
.I squashtypes
program collapses heirarchies of group types.  Each such heirarcy is
replaced with a single group type, under which are all the leaf fields
of all the groups at the appropriate absolute offsets.  This can be
useful for making the code more readable and to help back-end C
compilers -- some have trouble with very long heirarchies of group
types that get turned into long heirarchies of structures.  Such
heirarchies can be created by various code transformations.  For
example, padding between globals can be done by pairwise joining
globals into a new group type with two fields, and repeating this for
many globals leads to a deep heirarchy.
.SH HISTORY
This program was written by Chris Wilson.
